#! /usr/bin/env python
#
#    gtk_.widget_.py - Base class for gtk Widgets
#    Copyright (C) 2004  Michael Urman
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from gen import *


class Widget(GenClass):

    """Gtk.Widget"""
    
    __data__ = [
        ['widget', 'GtkWidget *']
    ]

    __code__ = '''
    gulong gtk__signal_handler(GtkWidget *widget, PyObject *handler_info)
    {
        PyObject *callback = PyTuple_GET_ITEM(handler_info, 0);
        PyObject *data = PyTuple_GET_ITEM(handler_info, 1);
        PyObject *kwdata = PyTuple_GET_ITEM(handler_info, 2);

        PyObject *result = PyEval_CallObjectWithKeywords(callback, data, kwdata);
        if (result == Py_None) {
            Py_DECREF(result);
            return 0;
        }
        else {
            gulong ret = PyInt_AsLong(result);
            Py_DECREF(result);
            return ret;
        }
    }
    '''

    def connect(self, event, callback, *data, **kwdata):
        """Connect an event signal on an object to a provided callback."""

        event = ['s', 'char *']
        callback = ['O', 'PyObject *']
        code = '''
        gulong handler_id;

        PyObject *handler_info = PyTuple_New(3);
        Py_INCREF(callback);
        PyTuple_SET_ITEM(handler_info, 0, callback);
        Py_INCREF(data);
        PyTuple_SET_ITEM(handler_info, 1, data);
        Py_INCREF(kwdata);
        PyTuple_SET_ITEM(handler_info, 2, kwdata);

        handler_id = g_signal_connect(G_OBJECT(self->widget), event,
            G_CALLBACK(gtk__signal_handler), handler_info);
        '''
        return locals()

    def show(self):
        code = '''
        gtk_widget_show(self->widget);
        '''
        return locals()

    def show_all(self):
        code = '''
        gtk_widget_show_all(self->widget);
        '''
        return locals()
