#! /usr/bin/env python
#
#    <one line to give the program's name and a brief idea of what it does.>
#    Copyright (C) 2004  Michael Urman
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

def pkgconfig(arg, id):
    return [
    d[len(id):]
    for d in os.popen('pkg-config %s gtk+-2.0'%arg, 'r').read().split()
    if d.startswith(id)]

from distutils.core import setup, Extension
import os
setup(name='gtk',
        ext_modules = [
            Extension('gtk',
                sources=['gtk.c'],
                define_macros=[(d, None) for d in pkgconfig('--cflags', '-D')],
                include_dirs=pkgconfig('--cflags', '-I'),
                libraries=pkgconfig('--libs', '-l'),
                library_dirs=pkgconfig('--libs', '-L'),
            )
        ]
)
